Index: trunk/NEMO/TOP_SRC/SMS/trcbio.F
===================================================================
--- trunk/NEMO/TOP_SRC/SMS/trcbio.F	(revision 433)
+++ trunk/NEMO/TOP_SRC/SMS/trcbio.F	(revision 656)
@@ -95,5 +95,8 @@
       INTEGER kt
       INTEGER ji,jj,jk,jn
-      REAL ztot(jpi), ze3t(jpk)
+      REAL ztot(jpi)
+#if defined key_trc_diaadd
+      REAL ze3t(jpi,jpj,jpk)
+endif
       REAL zdet,zzoo,zphy,zno3,znh4,zdom,zlno3,zlnh4,zle,zlt
       REAL zno3phy, znh4phy, zphynh4, zphydom, zphydet, zphyzoo, zdetzoo
@@ -117,9 +120,11 @@
 #if defined key_trc_diaadd
 C convert fluxes in per day
+      ze3t(:,:,:) = 0.
       DO jk=1,jpkbm1
-        ze3t(jk)=e3t(jk)*86400.
-      END DO 
-      DO jk=jpkb,jpk
-        ze3t(jk)=0.
+        DO jj = 2, jpjm1
+          DO ji = 2, jpim1
+            ze3t(ji,jj,jk)=fse3t(ji,jj,jk)*86400.
+          END DO
+        END DO
       END DO 
 #endif
@@ -282,25 +287,25 @@
 #endif
 #if defined key_trc_diaadd
-            trc2d(ji,jj,1)=trc2d(ji,jj,1)+zno3phy*ze3t(jk)          
-            trc2d(ji,jj,2)=trc2d(ji,jj,2)+znh4phy*ze3t(jk)
-            trc2d(ji,jj,3)=trc2d(ji,jj,3)+zphydom*ze3t(jk)
-            trc2d(ji,jj,4)=trc2d(ji,jj,4)+zphynh4*ze3t(jk)
-            trc2d(ji,jj,5)=trc2d(ji,jj,5)+zphyzoo*ze3t(jk)
-            trc2d(ji,jj,6)=trc2d(ji,jj,6)+zphydet*ze3t(jk)
-            trc2d(ji,jj,7)=trc2d(ji,jj,7)+zdetzoo*ze3t(jk)
+            trc2d(ji,jj,1)=trc2d(ji,jj,1)+zno3phy*ze3t(ji,jj,jk)          
+            trc2d(ji,jj,2)=trc2d(ji,jj,2)+znh4phy*ze3t(ji,jj,jk)
+            trc2d(ji,jj,3)=trc2d(ji,jj,3)+zphydom*ze3t(ji,jj,jk)
+            trc2d(ji,jj,4)=trc2d(ji,jj,4)+zphynh4*ze3t(ji,jj,jk)
+            trc2d(ji,jj,5)=trc2d(ji,jj,5)+zphyzoo*ze3t(ji,jj,jk)
+            trc2d(ji,jj,6)=trc2d(ji,jj,6)+zphydet*ze3t(ji,jj,jk)
+            trc2d(ji,jj,7)=trc2d(ji,jj,7)+zdetzoo*ze3t(ji,jj,jk)
 c trend number 8 is in trcsed.F            
-            trc2d(ji,jj,9)=trc2d(ji,jj,9)+zzoodet*ze3t(jk)
-            trc2d(ji,jj,10)=trc2d(ji,jj,10)+zzoobod*ze3t(jk)
-            trc2d(ji,jj,11)=trc2d(ji,jj,11)+zzoonh4*ze3t(jk)
-            trc2d(ji,jj,12)=trc2d(ji,jj,12)+zzoodom*ze3t(jk)
-            trc2d(ji,jj,13)=trc2d(ji,jj,13)+znh4no3*ze3t(jk)
-            trc2d(ji,jj,14)=trc2d(ji,jj,14)+zdomnh4*ze3t(jk)
-            trc2d(ji,jj,15)=trc2d(ji,jj,15)+zdetnh4*ze3t(jk)
+            trc2d(ji,jj,9)=trc2d(ji,jj,9)+zzoodet*ze3t(ji,jj,jk)
+            trc2d(ji,jj,10)=trc2d(ji,jj,10)+zzoobod*ze3t(ji,jj,jk)
+            trc2d(ji,jj,11)=trc2d(ji,jj,11)+zzoonh4*ze3t(ji,jj,jk)
+            trc2d(ji,jj,12)=trc2d(ji,jj,12)+zzoodom*ze3t(ji,jj,jk)
+            trc2d(ji,jj,13)=trc2d(ji,jj,13)+znh4no3*ze3t(ji,jj,jk)
+            trc2d(ji,jj,14)=trc2d(ji,jj,14)+zdomnh4*ze3t(ji,jj,jk)
+            trc2d(ji,jj,15)=trc2d(ji,jj,15)+zdetnh4*ze3t(ji,jj,jk)
              
             trc2d(ji,jj,16)=trc2d(ji,jj,16)+(zno3phy+znh4phy-zphynh4
-     $          -zphydom-zphyzoo-zphydet)*ze3t(jk)
+     $          -zphydom-zphyzoo-zphydet)*ze3t(ji,jj,jk)
             trc2d(ji,jj,17)=trc2d(ji,jj,17)+(zphyzoo+zdetzoo-zzoodet
-     $          -zzoobod-zzoonh4-zzoodom) *ze3t(jk)
-            trc2d(ji,jj,18)=trc2d(ji,jj,18)+zdetdom*ze3t(jk)
+     $          -zzoobod-zzoonh4-zzoodom) *ze3t(ji,jj,jk)
+            trc2d(ji,jj,18)=trc2d(ji,jj,18)+zdetdom*ze3t(ji,jj,jk)
 c trend number 19 is in trcexp.F
             trc3d(ji,jj,jk,1)= zno3phy *86400     
@@ -440,25 +445,25 @@
 #endif
 #if defined key_trc_diaadd
-            trc2d(ji,jj,1)=trc2d(ji,jj,1)+zno3phy*ze3t(jk)          
-            trc2d(ji,jj,2)=trc2d(ji,jj,2)+znh4phy*ze3t(jk)
-            trc2d(ji,jj,3)=trc2d(ji,jj,3)+zphydom*ze3t(jk)
-            trc2d(ji,jj,4)=trc2d(ji,jj,4)+zphynh4*ze3t(jk)
-            trc2d(ji,jj,5)=trc2d(ji,jj,5)+zphyzoo*ze3t(jk)
-            trc2d(ji,jj,6)=trc2d(ji,jj,6)+zphydet*ze3t(jk)
-            trc2d(ji,jj,7)=trc2d(ji,jj,7)+zdetzoo*ze3t(jk)
+            trc2d(ji,jj,1)=trc2d(ji,jj,1)+zno3phy*ze3t(ji,jj,jk)          
+            trc2d(ji,jj,2)=trc2d(ji,jj,2)+znh4phy*ze3t(ji,jj,jk)
+            trc2d(ji,jj,3)=trc2d(ji,jj,3)+zphydom*ze3t(ji,jj,jk)
+            trc2d(ji,jj,4)=trc2d(ji,jj,4)+zphynh4*ze3t(ji,jj,jk)
+            trc2d(ji,jj,5)=trc2d(ji,jj,5)+zphyzoo*ze3t(ji,jj,jk)
+            trc2d(ji,jj,6)=trc2d(ji,jj,6)+zphydet*ze3t(ji,jj,jk)
+            trc2d(ji,jj,7)=trc2d(ji,jj,7)+zdetzoo*ze3t(ji,jj,jk)
 Cc trend number 8 is in trcsed.F            
-            trc2d(ji,jj,9)=trc2d(ji,jj,9)+zzoodet*ze3t(jk)
-            trc2d(ji,jj,10)=trc2d(ji,jj,10)+zzoobod*ze3t(jk)
-            trc2d(ji,jj,11)=trc2d(ji,jj,11)+zzoonh4*ze3t(jk)
-            trc2d(ji,jj,12)=trc2d(ji,jj,12)+zzoodom*ze3t(jk)
-            trc2d(ji,jj,13)=trc2d(ji,jj,13)+znh4no3*ze3t(jk)
-            trc2d(ji,jj,14)=trc2d(ji,jj,14)+zdomnh4*ze3t(jk)
-            trc2d(ji,jj,15)=trc2d(ji,jj,15)+zdetnh4*ze3t(jk)
+            trc2d(ji,jj,9)=trc2d(ji,jj,9)+zzoodet*ze3t(ji,jj,jk)
+            trc2d(ji,jj,10)=trc2d(ji,jj,10)+zzoobod*ze3t(ji,jj,jk)
+            trc2d(ji,jj,11)=trc2d(ji,jj,11)+zzoonh4*ze3t(ji,jj,jk)
+            trc2d(ji,jj,12)=trc2d(ji,jj,12)+zzoodom*ze3t(ji,jj,jk)
+            trc2d(ji,jj,13)=trc2d(ji,jj,13)+znh4no3*ze3t(ji,jj,jk)
+            trc2d(ji,jj,14)=trc2d(ji,jj,14)+zdomnh4*ze3t(ji,jj,jk)
+            trc2d(ji,jj,15)=trc2d(ji,jj,15)+zdetnh4*ze3t(ji,jj,jk)
              
             trc2d(ji,jj,16)=trc2d(ji,jj,16)+(zno3phy+znh4phy-zphynh4
-     $          -zphydom-zphyzoo-zphydet)*ze3t(jk)
+     $          -zphydom-zphyzoo-zphydet)*ze3t(ji,jj,jk)
             trc2d(ji,jj,17)=trc2d(ji,jj,17)+(zphyzoo+zdetzoo-zzoodet
-     $          -zzoobod-zzoonh4-zzoodom) *ze3t(jk)
-            trc2d(ji,jj,18)=trc2d(ji,jj,18)+zdetdom*ze3t(jk)
+     $          -zzoobod-zzoonh4-zzoodom) *ze3t(ji,jj,jk)
+            trc2d(ji,jj,18)=trc2d(ji,jj,18)+zdetdom*ze3t(ji,jj,jk)
 
             trc3d(ji,jj,jk,1)= zno3phy *86400     