Index: /trunk/UTIL/fait_AA_make
===================================================================
--- /trunk/UTIL/fait_AA_make	(revision 665)
+++ /trunk/UTIL/fait_AA_make	(revision 666)
@@ -87,6 +87,5 @@
 	\$(P_P) \$(F_O) \\
 #-Q- fjvpp		-Z \$*.L \\
-#-Q- sxnec		-R2 \\
-#-Q- sx6nec		-R2 \\
+#-Q- sx8mercure		-R2 \\
 #-Q- sx8brodie		-R2 \\
 #-Q- sxdkrz		-R2 \\
@@ -94,9 +93,6 @@
 #-Q- aix		-qsource \\
 	   OPAFILES/\$*.F90 || { mv \$(PREF).L \$(TMP) ; false ; exit ; }
-#-Q- sxnec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx6nec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx8brodie		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 #-Q- sxdkrz		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- hpux			@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
+#-Q- eshpux			@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 endif
 
@@ -111,7 +107,4 @@
 # if the make script is stopped, one doesn't destroy library
 .PRECIOUS : \$(MODEL_LIB)
-#-Q- sxnec .PRECIOUS : \$(SXMODEL_LIB)
-#-Q- sx6nec .PRECIOUS : \$(SXMODEL_LIB)
-#-Q- sx8brodie .PRECIOUS : \$(SXMODEL_LIB)
 #-Q- sxdkrz .PRECIOUS : \$(SXMODEL_LIB)
 #-Q- eshpux .PRECIOUS : \$(SXMODEL_LIB)
@@ -130,6 +123,5 @@
 		@\$(F_C) \$(P_P) \$(F_O) \\
 #-Q- fjvpp		-Z \$*.L \\
-#-Q- sxnec		-R2 \\
-#-Q- sx6nec		-R2 \\
+#-Q- sx8mercure		-R2 \\
 #-Q- sx8brodie		-R2 \\
 #-Q- sxdkrz		-R2 \\
@@ -137,7 +129,4 @@
 #-Q- aix		-qsource \\
 		\$*.f90 || { if [ -f \$(PREF)\$*.L ] ; then mv \$(PREF)\$*.L \$(TMP) ; fi ; false ; exit ; }
-#-Q- sxnec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx6nec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx8brodie		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 #-Q- sxdkrz		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 #-Q- eshpux		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
@@ -166,6 +155,5 @@
 		@\$(F_C) \$(P_P) \$(F_O) \\
 #-Q- fjvpp		-Z \$*.L \\
-#-Q- sxnec		-R2 \\
-#-Q- sx6nec		-R2 \\
+#-Q- sx8mercure		-R2 \\
 #-Q- sx8brodie		-R2 \\
 #-Q- sxdkrz		-R2 \\
@@ -176,6 +164,5 @@
 		@\$(F_C) \$(P_P) \$(F_O) \\
 #-Q- fjvpp		-Z \$*.L \\
-#-Q- sxnec		-R2 \\
-#-Q- sx6nec		-R2 \\
+#-Q- sx8mercure		-R2 \\
 #-Q- sx8brodie		-R2 \\
 #-Q- sxdkrz		-R2 \\
@@ -184,7 +171,4 @@
 		\$*.F90 || { if [ -f \$(PREF)\$*.L ] ; then mv \$(PREF)\$*.L \$(TMP) ; fi ; false ; exit ; }
 endif
-#-Q- sxnec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx6nec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx8brodie		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 #-Q- sxdkrz		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 #-Q- eshpux		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
@@ -213,6 +197,5 @@
 		@\$(F_C) \$(P_P) \$(F_F) \\
 #-Q- fjvpp		-Z \$*.L \\
-#-Q- sxnec		-R2 \\
-#-Q- sx6nec		-R2 \\
+#-Q- sx8mercure		-R2 \\
 #-Q- sx8brodie		-R2 \\
 #-Q- sxdkrz		-R2 \\
@@ -223,6 +206,5 @@
 		@\$(F_C) \$(P_P) \$(F_O) \\
 #-Q- fjvpp		-Z \$*.L \\
-#-Q- sxnec		-R2 \\
-#-Q- sx6nec		-R2 \\
+#-Q- sx8mercure		-R2 \\
 #-Q- sx8brodie		-R2 \\
 #-Q- sxdkrz		-R2 \\
@@ -231,7 +213,4 @@
 		\$*.F || { if [ -f \$(PREF)\$*.L ] ; then mv \$(PREF)\$*.L \$(TMP) ; fi ; false ; exit ; }
 endif
-#-Q- sxnec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx6nec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx8brodie		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 #-Q- sxdkrz		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 #-Q- eshpux		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
@@ -248,6 +227,5 @@
 		@\$(F_C) \$(F_O) \\
 #-Q- fjvpp		-Z \$*.L \\
-#-Q- sxnec		-R2 \\
-#-Q- sx6nec		-R2 \\
+#-Q- sx8mercure		-R2 \\
 #-Q- sx8brodie		-R2 \\
 #-Q- sxdkrz		-R2 \\
@@ -255,7 +233,4 @@
 #-Q- aix		-qsource \\
 		\$*.f|| { if [ -f \$(PREF)\$*.L ] ; then mv \$*.L \$(TMP) ; fi ; false ; exit ; }
-#-Q- sxnec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx6nec		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
-#-Q- sx8brodie		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 #-Q- sxdkrz		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
 #-Q- eshpux		@\$(A_X) \$(SXMODEL_LIB) \$*.o  > /dev/null
@@ -275,13 +250,9 @@
 echo '# some variables'
 echo 'TMP = ../../../tmp'
-echo '#-Q- sxnec  # Compiler options for NEMO (IDRIS SX5-NEC) '
-echo '#-Q- sxnec  F_O = -dw -Wf\"-A idbl4\" -sx5 -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
-echo '#-Q- sxnec  F_F = $(F_O) -f3'
-echo '#-Q- sxnec  L_X = $(L_O)'
-echo '#-Q- sx6nec  # Compiler options NEMO (CEA SX6-NEC) '
-echo '#-Q- sx6nec  F_O = -size_t64 -dw -Wf\"-A dbl4\" -sx6 -C vopt -Wf"-P nh" -Wf',-pvctl noassume loopcnt=10000 -L transform' -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
-echo '#-Q- sx6nec  F_O = -size_t64 -dw -Wf\"-A dbl4\" -sx6 -ftrace -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
-echo '#-Q- sx6nec  F_F = $(F_O) -f3'
-echo '#-Q- sx6nec  L_X = $(L_O) -ftrace'
+echo '#-Q- sx8mercure  # Compiler options NEMO (CEA SX6-NEC) '
+echo '#-Q- sx8mercure  F_O = -size_t64 -dw -Wf\"-A dbl4\" -sx6 -C vopt -Wf"-P nh" -Wf',-pvctl noassume loopcnt=10000 -L transform' -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
+echo '#-Q- sx8mercure  F_O = -size_t64 -dw -Wf\"-A dbl4\" -sx6 -ftrace -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
+echo '#-Q- sx8mercure  F_F = $(F_O) -f3'
+echo '#-Q- sx8mercure  L_X = $(L_O) -ftrace'
 echo '#-Q- sx8brodie  # Compiler options NEMO (CEA SX6-NEC) '
 echo '#-Q- sx8brodie  F_O = -dw -Wf\"-A idbl4\" -sx8 -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
@@ -326,6 +297,5 @@
 
 echo 'PREF='
-echo '#-Q- sxnec	PREF=i.'
-echo '#-Q- sx6nec	PREF=i.'
+echo '#-Q- sx8mercure	PREF=i.'
 echo '#-Q- sx8brodie	PREF=i.'
 echo '#-Q- sxdkrz	PREF=i.'